libzypp: zypp::media::MediaMultiCurl Class Reference

libzypp 17.25.10

Public Member Functions | Protected Member Functions | Static Protected Member Functions | Private Attributes | Friends | List of all members
zypp::media::MediaMultiCurl Class Reference

`#include <MediaMultiCurl.h>`

Inheritance diagram for zypp::media::MediaMultiCurl:
[legend]

## Public Member Functions
| MediaMultiCurl (const Url &url_r, const Pathname &attach_point_hint_r)
| ~MediaMultiCurl () override
virtual void | doGetFileCopy (const Pathname &srcFilename, const Pathname &targetFilename, callback::SendReport< DownloadProgressReport > &_report, const ByteCount &expectedFileSize_r, RequestOptions options=OPTION_NONE) const override
void | multifetch (const Pathname &filename, FILE *fp, std::vector< Url > *urllist, callback::SendReport< DownloadProgressReport > *report=0, MediaBlockList *blklist=0, off_t filesize=off_t(-1)) const
void | multifetch (const Pathname &filename, FILE *fp, std::vector< Url > *urllist, callback::SendReport< DownloadProgressReport > *report, MediaBlockList *blklist, const ByteCount &filesize) const
Public Member Functions inherited from zypp::media::MediaCurl
| ZYPP_DECLARE_FLAGS (RequestOptions, RequestOption)
| MediaCurl (const Url &url_r, const Pathname &attach_point_hint_r)
virtual | ~MediaCurl () override
TransferSettings & | settings ()
Public Member Functions inherited from zypp::media::MediaHandler
| MediaHandler (const Url &url_r, const Pathname &attach_point_r, const Pathname &urlpath_below_attachpoint_r, const bool does_download_r)
| If the concrete media handler provides a nonempty attach_point, it must be an existing directory. More...
virtual | ~MediaHandler ()
| Contolling MediaAccess takes care, that attached media is released prior to deleting this. More...
bool | downloads () const
| Hint if files are downloaded or not. More...
std::string | protocol () const
| Protocol hint for MediaAccess. More...
Url | url () const
| Url used. More...
void | attach (bool next)
| Use concrete handler to attach the media. More...
virtual bool | isAttached () const
| True if media is attached. More...
Pathname | localRoot () const
| Return the local directory that corresponds to medias url, no matter if media isAttached or not. More...
Pathname | localPath (const Pathname &pathname) const
| Files provided will be available at 'localPath(filename)'. More...
void | disconnect ()
| Use concrete handler to isconnect media. More...
void | release (const std::string &ejectDev="")
| Use concrete handler to release the media. More...
void | provideFile (Pathname filename, const ByteCount &expectedFileSize_r) const
| Use concrete handler to provide file denoted by path below 'localRoot'. More...
void | provideFileCopy (Pathname srcFilename, Pathname targetFilename, const ByteCount &expectedFileSize_r) const
| Call concrete handler to provide a copy of a file under a different place in the file system (usually not under attach point) as a copy. More...
void | provideDir (Pathname dirname) const
| Use concrete handler to provide directory denoted by path below 'localRoot' (not recursive!). More...
void | provideDirTree (Pathname dirname) const
| Use concrete handler to provide directory tree denoted by path below 'localRoot' (recursive!!). More...
void | releaseFile (const Pathname &filename) const
| Remove filename below localRoot IFF handler downloads files to the local filesystem. More...
void | releaseDir (const Pathname &dirname) const
| Remove directory tree below localRoot IFF handler downloads files to the local filesystem. More...
void | releasePath (Pathname pathname) const
| Remove pathname below localRoot IFF handler downloads files to the local filesystem. More...
void | setDeltafile (const Pathname &filename=Pathname()) const
Pathname | deltafile () const
void | dirInfo (std::list< std::string > &retlist, const Pathname &dirname, bool dots=true) const
| Return content of directory on media via retlist. More...
void | dirInfo (filesystem::DirContent &retlist, const Pathname &dirname, bool dots=true) const
| Basically the same as dirInfo above. More...
bool | doesFileExist (const Pathname &filename) const
| check if a file exists More...
virtual bool | hasMoreDevices ()
| Check if the media has one more device available for attach(true). More...
virtual void | getDetectedDevices (std::vector< std::string > &devices, unsigned int &index) const
| Fill in a vector of detected ejectable devices and the index of the currently attached device within the vector. More...

## Protected Member Functions
bool | isDNSok (const std::string &host) const
void | setDNSok (const std::string &host) const
CURL * | fromEasyPool (const std::string &host) const
void | toEasyPool (const std::string &host, CURL *easy) const
virtual void | setupEasy () override
| initializes the curl easy handle with the data from the url More...
void | checkFileDigest (Url &url, FILE *fp, MediaBlockList *blklist) const
Protected Member Functions inherited from zypp::media::MediaCurl
Url | clearQueryString (const Url &url) const
virtual void | attachTo (bool next=false) override
| Call concrete handler to attach the media. More...
virtual void | releaseFrom (const std::string &ejectDev) override
| Call concrete handler to release the media. More...
virtual void | getFile (const Pathname &filename, const ByteCount &expectedFileSize_r) const override
| Call concrete handler to provide file below attach point. More...
virtual void | getDir (const Pathname &dirname, bool recurse_r) const override
| Call concrete handler to provide directory content (not recursive!) below attach point. More...
virtual void | getDirInfo (std::list< std::string > &retlist, const Pathname &dirname, bool dots=true) const override
| Call concrete handler to provide a content list of directory on media via retlist. More...
virtual void | getDirInfo (filesystem::DirContent &retlist, const Pathname &dirname, bool dots=true) const override
| Basically the same as getDirInfo above. More...
virtual bool | getDoesFileExist (const Pathname &filename) const override
| Repeatedly calls doGetDoesFileExist() until it successfully returns, fails unexpectedly, or user cancels the operation. More...
virtual bool | doGetDoesFileExist (const Pathname &filename) const
virtual void | disconnectFrom () override
virtual void | getFileCopy (const Pathname &srcFilename, const Pathname &targetFilename, const ByteCount &expectedFileSize_r) const override
virtual bool | checkAttachPoint (const Pathname &apoint) const override
| Verify if the specified directory as attach point (root) as requires by the particular media handler implementation. More...
void | checkProtocol (const Url &url) const
| check the url is supported by the curl library More...
Url | getFileUrl (const Pathname &filename) const
| concatenate the attach url and the filename to a complete download url More...
void | evaluateCurlCode (const zypp::Pathname &filename, CURLcode code, bool timeout) const
| Evaluates a curl return code and throws the right MediaException `filename` Filename being downloaded `code` Code curl returnes `timeout` Whether we reached timeout, which we need to differentiate in case the codes aborted-by-callback or timeout are returned by curl Otherwise we can't differentiate abort from timeout. More...
void | doGetFileCopyFile (const Pathname &srcFilename, const Pathname &dest, FILE *file, callback::SendReport< DownloadProgressReport > &_report, const ByteCount &expectedFileSize_r, RequestOptions options=OPTION_NONE) const
Protected Member Functions inherited from zypp::media::MediaHandler
bool | dependsOnParent (MediaAccessId parentId, bool exactIdMatch)
| Check if the current media handler depends on an another handler specified by media access id. More...
bool | dependsOnParent ()
void | resetParentId ()
| Called in case, where the media manager takes over the destruction of the parent id (e.g. More...
Pathname | attachPoint () const
| Return the currently used attach point. More...
void | setAttachPoint (const Pathname &path, bool temp)
| Set a new attach point. More...
void | setAttachPoint (const AttachPointRef &ref)
| Set a (shared) attach point. More...
AttachPoint | attachPointHint () const
| Get the actual attach point hint. More...
void | attachPointHint (const Pathname &path, bool temp)
| Set the attach point hint as specified by the user. More...
Pathname | createAttachPoint () const
| Try to create a default / temporary attach point. More...
Pathname | createAttachPoint (const Pathname &attach_root) const
| Try to create a temporary attach point in specified root. More...
void | removeAttachPoint ()
| Remove unused attach point. More...
bool | isUseableAttachPoint (const Pathname &path, bool mtab=true) const
| Ask media manager, if the specified path is already used as attach point or if there are another attach points bellow of it. More...
std::string | mediaSourceName () const
| Get the media source name or an empty string. More...
void | setMediaSource (const MediaSourceRef &ref)
| Set new media source reference. More...
AttachedMedia | findAttachedMedia (const MediaSourceRef &media) const
| Ask the media manager if specified media source is already attached. More...
AttachedMedia | attachedMedia () const
| Returns the attached media. More...
bool | isSharedMedia () const
| Returns a hint if the media is shared or not. More...
bool | checkAttached (bool matchMountFs) const
| Check actual mediaSource attachment against the current mount table of the system. More...
void | forceRelaseAllMedia (bool matchMountFs)
| Call to this function will try to release all media matching the currenlty attached media source, that it is able to find in the mount table. More...
void | forceRelaseAllMedia (const MediaSourceRef &ref, bool matchMountFs)
virtual void | forceEject (const std::string &device)
| Call concrete handler to physically eject the media (i.e. More...
void | getDirectoryYast (std::list< std::string > &retlist, const Pathname &dirname, bool dots=true) const
| Retrieve and if available scan dirname/directory.yast. More...
void | getDirectoryYast (filesystem::DirContent &retlist, const Pathname &dirname, bool dots=true) const
| Retrieve and if available scan dirname/directory.yast. More...

## Static Protected Member Functions
static int | progressCallback (void *clientp, double dltotal, double dlnow, double ultotal, double ulnow)
Static Protected Member Functions inherited from zypp::media::MediaCurl
static int | aliveCallback (void *clientp, double dltotal, double dlnow, double ultotal, double ulnow)
static int | progressCallback (void *clientp, double dltotal, double dlnow, double ultotal, double ulnow)
| Callback reporting download progress. More...
static CURL * | progressCallback_getcurl (void *clientp)
static void | resetExpectedFileSize (void *clientp, const ByteCount &expectedFileSize)
| MediaMultiCurl needs to reset the expected filesize in case a metalink file is downloaded otherwise this function should not be called. More...
Static Protected Member Functions inherited from zypp::media::MediaHandler
static bool | checkAttachPoint (const Pathname &apoint, bool empty_dir, bool writeable)
| Verify if the specified directory as attach point (root) using requested checks. More...

## Private Attributes
curl_slist * | _customHeadersMetalink
CURLM * | _multi
std::set< std::string > | _dnsok
std::map< std::string, CURL * > | _easypool

## Friends
class | multifetchrequest
class | multifetchworker

## Additional Inherited Members
Public Types inherited from zypp::media::MediaCurl
enum | RequestOption { OPTION_NONE = 0x0 , OPTION_RANGE = 0x1 , OPTION_HEAD = 0x02 , OPTION_NO_IFMODSINCE = 0x04 , OPTION_NO_REPORT_START = 0x08 }
Public Types inherited from zypp::media::MediaHandler
typedef shared_ptr< MediaHandler > | Ptr
typedef shared_ptr< const MediaHandler > | constPtr
Static Public Member Functions inherited from zypp::media::MediaCurl
static void | setCookieFile (const Pathname &)
Static Public Member Functions inherited from zypp::media::MediaHandler
static bool | setAttachPrefix (const Pathname &attach_prefix)
static std::string | getRealPath (const std::string &path)
static Pathname | getRealPath (const Pathname &path)
Protected Attributes inherited from zypp::media::MediaCurl
CURL * | _curl
char | _curlError [CURL_ERROR_SIZE]
curl_slist * | _customHeaders
TransferSettings | _settings
Protected Attributes inherited from zypp::media::MediaHandler
const Url | _url
| Url to handle. More...
MediaAccessId | _parentId
| Access Id of media handler we depend on. More...

## Detailed Description

Definition at line 40 of file MediaMultiCurl.h.

## Constructor & Destructor Documentation

## ◆ MediaMultiCurl()

zypp::media::MediaMultiCurl::MediaMultiCurl | ( | const Url & | url_r,
|  | const Pathname & | attach_point_hint_r
| ) |  |

Definition at line 1162 of file MediaMultiCurl.cc.

## ◆ ~MediaMultiCurl()

zypp::media::MediaMultiCurl::~MediaMultiCurl | ( |  | ) |
| override

Definition at line 1170 of file MediaMultiCurl.cc.

## Member Function Documentation

## ◆ doGetFileCopy()

void zypp::media::MediaMultiCurl::doGetFileCopy | ( | const Pathname & | srcFilename,
|  | const Pathname & | targetFilename,
|  | callback::SendReport< DownloadProgressReport > & | _report,
|  | const ByteCount & | expectedFileSize_r,
|  | RequestOptions | options = `OPTION_NONE`
| ) |  | const
| overridevirtual

Exceptions

  MediaException |

Reimplemented from zypp::media::MediaCurl.

Definition at line 1299 of file MediaMultiCurl.cc.

## ◆ multifetch() [1/2]

void zypp::media::MediaMultiCurl::multifetch | ( | const Pathname & | filename,
|  | FILE * | fp,
|  | std::vector< Url > * | urllist,
|  | callback::SendReport< DownloadProgressReport > * | report = `0`,
|  | MediaBlockList * | blklist = `0`,
|  | off_t | filesize = `off_t(-1)`
| ) |  | const

Definition at line 1507 of file MediaMultiCurl.cc.

## ◆ multifetch() [2/2]

void zypp::media::MediaMultiCurl::multifetch | ( | const Pathname & | filename,
|  | FILE * | fp,
|  | std::vector< Url > * | urllist,
|  | callback::SendReport< DownloadProgressReport > * | report,
|  | MediaBlockList * | blklist,
|  | const ByteCount & | filesize
| ) |  | const
| inline

Definition at line 55 of file MediaMultiCurl.h.

## ◆ isDNSok()

bool zypp::media::MediaMultiCurl::isDNSok | ( | const std::string & | host | ) | const
| protected

Definition at line 1575 of file MediaMultiCurl.cc.

## ◆ setDNSok()

void zypp::media::MediaMultiCurl::setDNSok | ( | const std::string & | host | ) | const
| protected

Definition at line 1580 of file MediaMultiCurl.cc.

## ◆ fromEasyPool()

CURL * zypp::media::MediaMultiCurl::fromEasyPool | ( | const std::string & | host | ) | const
| protected

Definition at line 1585 of file MediaMultiCurl.cc.

## ◆ toEasyPool()

void zypp::media::MediaMultiCurl::toEasyPool | ( | const std::string & | host,
|  | CURL * | easy
| ) |  | const
| protected

Definition at line 1594 of file MediaMultiCurl.cc.

## ◆ setupEasy()

void zypp::media::MediaMultiCurl::setupEasy | ( |  | ) |
| overrideprotectedvirtual

initializes the curl easy handle with the data from the url

Exceptions

  MediaCurlSetOptException | if there is a problem

Force IPv4/v6

Connect timeout

Speed limits

Reimplemented from zypp::media::MediaCurl.

Definition at line 1194 of file MediaMultiCurl.cc.

## ◆ checkFileDigest()

void zypp::media::MediaMultiCurl::checkFileDigest | ( | Url & | url,
|  | FILE * | fp,
|  | MediaBlockList * | blklist
| ) |  | const
| protected

Definition at line 1559 of file MediaMultiCurl.cc.

## ◆ progressCallback()

int zypp::media::MediaMultiCurl::progressCallback | ( | void * | clientp,
|  | double | dltotal,
|  | double | dlnow,
|  | double | ultotal,
|  | double | ulnow
| ) |  |
| staticprotected

Definition at line 1248 of file MediaMultiCurl.cc.

## Friends And Related Function Documentation

## ◆ multifetchrequest

friend class multifetchrequest
| friend

Definition at line 42 of file MediaMultiCurl.h.

## ◆ multifetchworker

friend class multifetchworker
| friend

Definition at line 43 of file MediaMultiCurl.h.

## Member Data Documentation

## ◆ _customHeadersMetalink

curl_slist* zypp::media::MediaMultiCurl::_customHeadersMetalink
| private

Definition at line 72 of file MediaMultiCurl.h.

## ◆ _multi

CURLM* zypp::media::MediaMultiCurl::_multi
| mutableprivate

Definition at line 73 of file MediaMultiCurl.h.

## ◆ _dnsok

std::set<std::string> zypp::media::MediaMultiCurl::_dnsok
| mutableprivate

Definition at line 74 of file MediaMultiCurl.h.

## ◆ _easypool

std::map<std::string, CURL *> zypp::media::MediaMultiCurl::_easypool
| mutableprivate

Definition at line 75 of file MediaMultiCurl.h.

The documentation for this class was generated from the following files:

- zypp/media/MediaMultiCurl.h
- zypp/media/MediaMultiCurl.cc